#!/usr/bin/env ruby

# webrick-app.rb [port]

$LOAD_PATH.unshift('../../lib')
require 'webrick'
require 'cgikit'
require 'cgikit/webrick'

port = (ARGV.shift || 8080).to_i

app = CGIKit::Application.new
app.load_all_components('./components')
app.component_path = 'components'
app.log_options = {:level => :fatal, :name => 'ErrorScreen', :file => 'log.txt'}

server = WEBrick::HTTPServer.new({:Port => port})
server.mount('/', WEBrick::CGIKitServlet::ApplicationHandler, app)

trap("INT"){ server.shutdown }
server.start
